package org.processmining.logprojection;

import gnu.trove.map.TObjectIntMap;

import java.io.Serializable;
import java.util.Collection;
import java.util.Map;

import org.deckfour.xes.extension.XExtension;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XTrace;

public class XTraceDataManager extends DataManager<XTrace> {

	private static final long serialVersionUID = 6437630112142200957L;

	private final Map<String, XExtension> key2extension;

	public <M extends Map<String, XExtension> & Serializable> XTraceDataManager(
			M key2extension, StringHandler stringHandler,
			Collection<XAttribute> attributes, TObjectIntMap<String> lit2index) {
		super(stringHandler, attributes, lit2index, 512 * 1024, 1, false);
		this.key2extension = key2extension;
	}

	public int getTraceSize(int number) {
		int block = (number * bytesReservedPerObject) >>> shift;
		int ptr = (number * bytesReservedPerObject) & mask;
		byte[] array = store[block];

		// The number of events can be read from the stream
		return readInt(array, ptr);
	}

	@Override
	protected XTrace readObjectFromBlock(byte[] block, int ptr,
			boolean forAddingAttributes) {
		XAttributeMap attributes = FACTORY.createAttributeMap();

		Attribute[] globalKeys = getKeys();

		for (int i = 0; i < globalKeys.length; i++) {
			readAttributeIntoScope(globalKeys, ptr, block, i, attributes,
					key2extension, forAddingAttributes);
		}
		return FACTORY.createTrace(attributes);
	}

}
