package org.processmining.logprojection.abstraction;

public interface CausalDependencyMatrix {

	/**
	 * Returns a value between 0 and 1 indicating the strenght of the causal
	 * depencencies between two nodes.
	 * 
	 * 
	 * @param node1
	 * @param node2
	 * @return
	 */
	public double getCausalDependency(int node1, int node2);

	public int getCount(int node1, int node2);

	public int getNumberOfNodes();

	public int getOccurenceCount(int i);

	public String getEventClass(int i);
}
