package org.processmining.logprojection.calculators;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XEvent;
import org.processmining.logprojection.Attribute;
import org.processmining.logprojection.DataManager.AttributeValueCalculator;

public class ClassifierValueCalculator implements
		AttributeValueCalculator<XEvent> {

	private final XEventClassifier classifier;
	private final Attribute attribute;
	private final String key;

	public ClassifierValueCalculator(XEventClassifier classifier) {
		this.classifier = classifier;
		this.key = classifier.name();
		this.attribute = new ClassifierAttribute(getKey(), Attribute.LITR, 0,
				classifier.getDefiningAttributeKeys());
	}

	public String getKey() {
		return key;
	}

	public Attribute getAttribute() {
		return attribute;
	}

	@Override
	public XAttribute[] computeAttributes(XEvent object, int objectIndex,
			int... header) {
		String value = classifier.getClassIdentity(object);
		return new XAttribute[] { new XLightLiteralAttribute(key, value) };
	}

}
