package org.processmining.logprojection.plugins.dottedchart.ui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridLayout;
import java.awt.RenderingHints;
import java.util.Iterator;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.jfree.chart.LegendItem;
import org.jfree.chart.block.LineBorder;
import org.jfree.chart.event.PlotChangeEvent;
import org.jfree.chart.event.PlotChangeListener;
import org.jfree.chart.title.LegendTitle;
import org.jfree.ui.RectangleEdge;
import org.jfree.ui.RectangleInsets;
import org.processmining.logprojection.plugins.dottedchart.DottedChart;

import com.fluxicon.slickerbox.factory.SlickerDecorator;

public class LegendDialog extends JScrollPane implements PlotChangeListener {

	private DottedChart dottedChart;
	private JPanel panel;

	public LegendDialog(DottedChart dottedChart) {
		//		super("Legend");
		//		super(window, "legend");
		//		this.setAlwaysOnTop(true);
		//		this.setLocationRelativeTo(window);
		//		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

		this.dottedChart = dottedChart;
		panel = new JPanel();
		panel.setLayout(new GridLayout(20, 0));

		dottedChart.addChangeListener(this);
		plotChanged(null);
		this.setViewportView(panel);
		//		JScrollPane scroll = new JScrollPane(panel);
		SlickerDecorator.instance().decorate(this, Color.LIGHT_GRAY, Color.GRAY, Color.DARK_GRAY);
		setVerticalScrollBarPolicy(VERTICAL_SCROLLBAR_NEVER);
		setHorizontalScrollBarPolicy(HORIZONTAL_SCROLLBAR_ALWAYS);
		//		setLayout(new BorderLayout());
		//		add(scroll);
		//		validate();
		//		repaint();
		//		setLocation(0, 0);

		//		pack();
		//		setVisible(true);

	}

	public void plotChanged(PlotChangeEvent arg0) {

		LegendTitle legend = new LegendTitle(dottedChart);
		legend.setMargin(new RectangleInsets(1.0, 1.0, 1.0, 1.0));
		legend.setFrame(new LineBorder());
		legend.setBackgroundPaint(Color.white);
		legend.setPosition(RectangleEdge.BOTTOM);

		panel.removeAll();
		panel.repaint();
		Iterator iterator = dottedChart.getLegendItems().iterator();
		while (iterator.hasNext()) {
			final LegendItem item = (LegendItem) iterator.next();
			JLabel label = new JLabel(item.getLabel()) {
				@Override
				public void paint(Graphics g) {
					Graphics2D g2d = (Graphics2D) g;
					g2d.setPaint(item.getLabelPaint());
					g2d.setFont(item.getLabelFont());
					g2d.translate(15, 0);
					super.paint(g);
					g2d.translate(-12, Math.max((getHeight() - 10) / 2, 0));
					g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
					g2d.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
					g2d.setPaint(item.getFillPaint());
					g2d.fill(item.getShape());
				}
			};
			label.setPreferredSize(new Dimension((int) label.getPreferredSize().getWidth() + 15, 12));

			panel.add(label);
		}
		panel.invalidate();
		invalidate();
		revalidate();

	}
}
